/*----------------------------------------------------------------------------------------------------------------*/
// ******************************* THESE ARE THE INFORMATIONS OF THE MAP: *************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// THE AUTUMN WAR:
// CREATED BY PAPADAN:
// MARCH 2007:
/*----------------------------------------------------------------------------------------------------------------*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// **************************************** CHOOSE THE NATIVE TRIBES: ******************************************* //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*================================================================================================================*/
        int subCiv0=-1;
        int subCiv1=-1;
		int subCiv2=-1;
		int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois"); 
		
		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");
		
		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");
   }		
/*================================================================================================================*/
// TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP SIZE: *********************************************** //
/*================================================================================================================*/
	    int playerTiles = 25000;
	    
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/
	    // SET THE MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0); 
	
	    // SET MAP ELEVATION HEIGHT BLEND:
	    rmSetMapElevationHeightBlend(1.0);

	    // PICKS A DEFAULT WATER HEIGHT:
		rmSetSeaLevel(4.0);
	    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// PICKS DEFAULT TERRAIN AND WATER:
		rmSetSeaType("new england coast");
	    
		// SET BASE TERRAIN MIX:
		//rmSetBaseTerrainMix("saguenay tundra");
	
	    // PICKS THE TERRAIN INITIALIZATION:
	    rmTerrainInitialize("new_england\ground1_ne",4);
		//rmTerrainInitialize("water");
	
	    // SET THE MAP TYPE:
		rmSetMapType("newEngland");
	    rmSetMapType("water");
		rmSetMapType("grass");
	    
	    // SET THE LIGHTING:
		rmSetLightingSet("new england");
	    		
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);

	    // CHOOSE THE MERCS:
	    chooseMercs();

	    // CORNER CONSTRAINT:
	    rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************* DEFINE THE CLASSES: ********************************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	    int classPlayer=rmDefineClass("player");
	    rmDefineClass("startingUnit");
	    rmDefineClass("classForest");
	    rmDefineClass("importantItem");
	    rmDefineClass("natives");
		rmDefineClass("nuggets");
		rmDefineClass("SocketClass");
	    int classbigContinent=rmDefineClass("big continent");
		rmDefineClass("region1");
		rmDefineClass("corner");
		rmDefineClass("bay");
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ********************************************* //
/*================================================================================================================*/
	    // MAP EDGE CONSTRAINT:
		int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
  		int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 12.0);

	    // PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 15.0);
		
		// Bonus area constraint.
        int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 15.0);
	   
	    // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	    	
	    // SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "FishCod", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
		int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 50.0);
        	
	    // NATIVES AVOIDANCE:
	    int avoidNatives=rmCreateClassDistanceConstraint("stuff avoid natives", rmClassID("natives"), 15.0);
		
	    // SILVER MINES CONSTRAINT:
	    int avoidCoin=rmCreateTypeDistanceConstraint("stuff avoid silver", "Mine", 15.0);
		
		// RANDOM TREES AVOIDANCE:
	    int avoidTrees=rmCreateTypeDistanceConstraint("stuff avoid Trees", "TreeNewEngland", 5.0);
		
		// GOLD MINES CONSTRAINT:
	    int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("stuff avoid close gold", "minegold", 1.0);
	    	
	    // FOREST CONSTRAINT:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	    
	    // IMPORTANT ITEM AVOIDANCE:
	    int avoidImportantItem=rmCreateClassDistanceConstraint("short avoid important", rmClassID("importantItem"), 5.0);

	    // DECORATIONS AVOIDANCE:
	    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	    // NUGGETS AVOIDANCE:
	    int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("nuggets"), 10.0);
		
		// REGIONS AVOIDANCE:
	    int avoidRegion=rmCreateClassDistanceConstraint("stuff vs. region", rmClassID("region1"), 20.0);
	    		
	    // RESOURCE AVOIDANCE:
	    int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
	
	    // ANIMALS CONSTRAINTS:
	    int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
		int avoidTurkey=rmCreateTypeDistanceConstraint("stuff avoids turkey", "turkey", 10.0);
		int avoidElk=rmCreateTypeDistanceConstraint("stuff avoids elk", "elk", 10.0);
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
	    int avoidBison=rmCreateTypeDistanceConstraint("stuff avoid Bison", "Bison", 15);
		int avoidMoose=rmCreateTypeDistanceConstraint("stuff avoid Moose", "moose", 15);
	    int avoidPronghorn=rmCreateTypeDistanceConstraint("stuff avoid Pronghorn", "Pronghorn", 15);
		int avoidCaribou=rmCreateTypeDistanceConstraint("stuff avoids Caribou", "caribou", 10.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoids fruits", "berrybush", 15.0);
	
	    // TRADE ROUTE CONSTRAINT:
	    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("SocketClass"), 8.0);
  	
	    // STARTING UNIT AVOIDANCE:
	    int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
	    int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
		
        // CONSTRAINT TO AVOID WATER:
		int avoidWater1 = rmCreateTerrainDistanceConstraint("avoid water 1", "Land", false, 1.0);
		int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water 4", "Land", false, 4.0);
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water 8", "Land", false, 8.0);
        int avoidWater16 = rmCreateTerrainDistanceConstraint("avoid water 16", "Land", false, 16.0);
		
		// SPECIFY TRUE SO CONSTRAINT STAYS OUTSIDE OF CIRCLE: (i.e. inside corners)
        int cornerConstraint0=rmCreateCornerConstraint("in corner 0", 0, true);
        int cornerConstraint1=rmCreateCornerConstraint("in corner 1", 1, true);
        int cornerConstraint2=rmCreateCornerConstraint("in corner 2", 2, true);
        int cornerConstraint3=rmCreateCornerConstraint("in corner 3", 3, true);
		
		// NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
		
	    // CIRCLE CONSTRAINT:
	    int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE REGIONS: **************************************** //
/*================================================================================================================*/
        int Region1ID=rmCreateArea("The Region 1");
        rmSetAreaSize(Region1ID, 0.07, 0.07);		
        rmSetAreaWarnFailure(Region1ID, false);
        
		rmAddAreaConstraint(Region1ID, avoidGold);
		rmAddAreaConstraint(Region1ID, playerConstraint);
		rmAddAreaConstraint(Region1ID, avoidRegion);
        
		rmAddAreaToClass(Region1ID, rmClassID("region1"));
        rmSetAreaSmoothDistance(Region1ID, 25);
		//rmSetAreaMix(Region1ID, "rockies_snow");
	    //rmSetAreaMix(Region1ID, "newengland_grass");
        rmSetAreaElevationType(Region1ID, cElevTurbulence);
        rmSetAreaElevationVariation(Region1ID, 2.0);
        rmSetAreaBaseHeight(Region1ID, 6.0);
        rmSetAreaElevationMinFrequency(Region1ID, 0.09);
        rmSetAreaElevationOctaves(Region1ID, 3);
        rmSetAreaElevationPersistence(Region1ID, 0.2);      
	    rmSetAreaCoherence(Region1ID, 0.5);
	    rmSetAreaLocation(Region1ID, 0.65, 0.65);
		rmSetAreaEdgeFilling(Region1ID, 5);
		rmSetAreaObeyWorldCircleConstraint(Region1ID, false);
	    rmBuildArea(Region1ID);
/*================================================================================================================*/
        int Region2ID=rmCreateArea("The Region 2");
        rmSetAreaSize(Region2ID, 0.20, 0.20);		
        rmSetAreaWarnFailure(Region2ID, false);
        
		rmAddAreaConstraint(Region2ID, avoidGold);
		rmAddAreaConstraint(Region2ID, playerConstraint);
		//rmAddAreaConstraint(Region2ID, avoidRegion);
        
		rmAddAreaToClass(Region2ID, rmClassID("region1"));
        rmSetAreaSmoothDistance(Region2ID, 25);
	    //rmSetAreaMix(Region2ID, "texas_grass");
        rmSetAreaElevationType(Region2ID, cElevTurbulence);
        rmSetAreaElevationVariation(Region2ID, 2.0);
        rmSetAreaBaseHeight(Region2ID, 6.0);
        rmSetAreaElevationMinFrequency(Region2ID, 0.09);
        rmSetAreaElevationOctaves(Region2ID, 3);
        rmSetAreaElevationPersistence(Region2ID, 0.2);      
	    rmSetAreaCoherence(Region2ID, 0.5);
	    rmSetAreaLocation(Region2ID, 0.0, 0.0);
		rmSetAreaEdgeFilling(Region2ID, 5);
		rmSetAreaObeyWorldCircleConstraint(Region2ID, false);
	    rmBuildArea(Region2ID);	
/*================================================================================================================*/
        int Region3ID=rmCreateArea("The Region 3");
        rmSetAreaSize(Region3ID, 0.05, 0.05);		
        rmSetAreaWarnFailure(Region3ID, false);
        
		rmAddAreaConstraint(Region3ID, avoidGold);
		rmAddAreaConstraint(Region3ID, playerConstraint);
		//rmAddAreaConstraint(Region3ID, avoidRegion);
        
		rmAddAreaToClass(Region3ID, rmClassID("region1"));
        rmSetAreaSmoothDistance(Region3ID, 25);
	    //rmSetAreaMix(Region3ID, "rockies_snow");
        rmSetAreaElevationType(Region3ID, cElevTurbulence);
        rmSetAreaElevationVariation(Region3ID, 2.0);
        rmSetAreaBaseHeight(Region3ID, 6.0);
        rmSetAreaElevationMinFrequency(Region3ID, 0.09);
        rmSetAreaElevationOctaves(Region3ID, 3);
        rmSetAreaElevationPersistence(Region3ID, 0.2);      
	    rmSetAreaCoherence(Region3ID, 0.5);
	    rmSetAreaLocation(Region3ID, 0.0, 0.6);
		rmSetAreaEdgeFilling(Region3ID, 5);
		rmSetAreaObeyWorldCircleConstraint(Region3ID, false);
	    rmBuildArea(Region3ID);				
/*================================================================================================================*/
        int Region4ID=rmCreateArea("The Region 4");
        rmSetAreaSize(Region4ID, 0.05, 0.05);		
        rmSetAreaWarnFailure(Region4ID, false);
        
		rmAddAreaConstraint(Region4ID, avoidGold);
		rmAddAreaConstraint(Region4ID, playerConstraint);
		//rmAddAreaConstraint(Region4ID, avoidRegion);
        
		rmAddAreaToClass(Region4ID, rmClassID("region1"));
        rmSetAreaSmoothDistance(Region4ID, 25);
	    //rmSetAreaMix(Region4ID, "rockies_snow");
        rmSetAreaElevationType(Region4ID, cElevTurbulence);
        rmSetAreaElevationVariation(Region4ID, 2.0);
        rmSetAreaBaseHeight(Region4ID, 6.0);
        rmSetAreaElevationMinFrequency(Region4ID, 0.09);
        rmSetAreaElevationOctaves(Region4ID, 3);
        rmSetAreaElevationPersistence(Region4ID, 0.2);      
	    rmSetAreaCoherence(Region4ID, 0.5);
	    rmSetAreaLocation(Region4ID, 0.6, 0.0);
		rmSetAreaEdgeFilling(Region4ID, 5);
		rmSetAreaObeyWorldCircleConstraint(Region4ID, false);
	    rmBuildArea(Region4ID);	
/*================================================================================================================*/
        int Region5ID=rmCreateArea("The Region 5");
        rmSetAreaSize(Region5ID, 0.015, 0.015);		
        rmSetAreaWarnFailure(Region5ID, false);
        
		rmAddAreaConstraint(Region5ID, avoidGold);
		rmAddAreaConstraint(Region5ID, playerConstraint);
		//rmAddAreaConstraint(Region5ID, avoidRegion);
        
		rmAddAreaToClass(Region5ID, rmClassID("region1"));
        rmSetAreaSmoothDistance(Region5ID, 25);
	    //rmSetAreaMix(Region5ID, "rockies_snow");
        rmSetAreaElevationType(Region5ID, cElevTurbulence);
        rmSetAreaElevationVariation(Region5ID, 2.0);
        rmSetAreaBaseHeight(Region5ID, 6.0);
        rmSetAreaElevationMinFrequency(Region5ID, 0.09);
        rmSetAreaElevationOctaves(Region5ID, 3);
        rmSetAreaElevationPersistence(Region5ID, 0.2);      
	    rmSetAreaCoherence(Region5ID, 0.5);
	    rmSetAreaLocation(Region5ID, 0.25, 0.25);
		rmSetAreaEdgeFilling(Region5ID, 5);
		rmSetAreaObeyWorldCircleConstraint(Region5ID, false);
	    rmBuildArea(Region5ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*================================================================================================================*/
        int Gold1ID=rmCreateObjectDef("The Gold Mine");
        rmAddObjectDefItem(Gold1ID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(Gold1ID, 0.0);
        rmSetObjectDefMaxDistance(Gold1ID, 0.0);
        rmAddObjectDefConstraint(Gold1ID, avoidGold);
	    //rmAddObjectDefConstraint(Gold1ID, avoidAll);
	    //rmAddObjectDefConstraint(Gold1ID, playerConstraint);
	    //rmAddObjectDefConstraint(Gold1ID, avoidCliffs);
        //rmAddObjectDefConstraint(Gold1ID, avoidWater8);
	    rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.2, 0.8);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.8, 0.2);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.3, 0.6);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.45, 0.45);
		rmPlaceObjectDefAtLoc(Gold1ID, 0, 0.6, 0.3);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************************** CREATE SOME BAY AREAS: ******************************************** //
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE 3 BAY AREAS: ************************************* //
/*================================================================================================================*/

        int bay1ID=rmCreateArea("Bay 1");
        rmSetAreaSize(bay1ID, 0.2, 0.2);
	    rmSetAreaLocation(bay1ID, 0.0, 0.0);
	    rmAddAreaConstraint(bay1ID, avoidGold);
	    rmSetAreaWaterType(bay1ID, "hudson bay");
        rmSetAreaBaseHeight(bay1ID, 1.0); // Was 10
        rmSetAreaMinBlobs(bay1ID, 1);
        rmSetAreaMaxBlobs(bay1ID, 1);
        rmSetAreaMinBlobDistance(bay1ID, 1);
        rmSetAreaMaxBlobDistance(bay1ID, 1);
        rmSetAreaSmoothDistance(bay1ID, 50);
        rmSetAreaCoherence(bay1ID, 0.4);
	    rmAddAreaToClass(bay1ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay1ID, false);
	    rmBuildArea(bay1ID);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int bay2ID=rmCreateArea("Bay 2");
        rmSetAreaSize(bay2ID, 0.06, 0.05);
	    rmSetAreaLocation(bay2ID, 0.0, 0.6);
	    rmAddAreaConstraint(bay2ID, avoidGold);
	    rmSetAreaWaterType(bay2ID, "hudson bay");
        rmSetAreaBaseHeight(bay2ID, 1.0); // Was 10
        rmSetAreaMinBlobs(bay2ID, 1);
        rmSetAreaMaxBlobs(bay2ID, 1);
        rmSetAreaMinBlobDistance(bay2ID, 1);
        rmSetAreaMaxBlobDistance(bay2ID, 1);
        rmSetAreaSmoothDistance(bay2ID, 50);
        rmSetAreaCoherence(bay2ID, 0.4);
	    rmAddAreaToClass(bay2ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay2ID, false);
        rmBuildArea(bay2ID);

/*----------------------------------------------------------------------------------------------------------------*/		

        int bay3ID=rmCreateArea("Bay 3");
        rmSetAreaSize(bay3ID, 0.05, 0.05);
        rmSetAreaLocation(bay3ID, 0.6, 0.0);
        rmAddAreaConstraint(bay3ID, avoidGold);
	    rmSetAreaWaterType(bay3ID, "hudson bay");
        rmSetAreaBaseHeight(bay3ID, 1.0); // Was 10
        rmSetAreaMinBlobs(bay3ID, 1);
        rmSetAreaMaxBlobs(bay3ID, 1);
        rmSetAreaMinBlobDistance(bay3ID, 1);
        rmSetAreaMaxBlobDistance(bay3ID, 1);
        rmSetAreaSmoothDistance(bay3ID, 50);
        rmSetAreaCoherence(bay3ID, 0.3);
	    rmAddAreaToClass(bay3ID, rmClassID("bay"));
        rmSetAreaObeyWorldCircleConstraint(bay3ID, false);
        rmBuildArea(bay3ID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *************************************** SET UP THE PLAYERS LOCATIONS: **************************************** //
/*================================================================================================================*/

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(0);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  //rmPlacePlayer(1,0.20,0.50);
		  rmPlacePlayer(1,0.35,0.85);

        //rmSetPlacementTeam(long teamID)
		  rmSetPlacementTeam(1);
		  
        //rmPlacePlayer(int playerID, float xFraction, float zFraction); 
		  //rmPlacePlayer(2,0.80,0.50);
		  rmPlacePlayer(2,0.85,0.35);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************* DEFINE THE SET UP PLAYER AREAS ***************************************** //
/*================================================================================================================*/
	    float playerFraction=rmAreaTilesToFraction(120);   //KSW ---> Was 100
	    for(i=1; <cNumberPlayers)
	{
		// CREATE THE AREA:
		int id=rmCreateArea("Player"+i);
		
		// ASSIGN TO THE PLAYER:
		rmSetPlayerArea(i, id);
		
		// SET THE SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
		
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
		
		// SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		
		// SET THE CONSTRAINTS:
		//rmAddAreaConstraint(id, playerConstraint); 
		//rmAddAreaConstraint(id, playerEdgeConstraint); 
		
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);

		// SET AREA MIX:
		//rmSetAreaMix(id, "saguenay tundra");
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	    // BUILD THE AREAS:
        rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE TRADE ROUTE NUMBER 1: ********************************** //
/*================================================================================================================*/
	  int tradeRouteID = rmCreateTradeRoute();
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.90);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.65);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.5, 0.5);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.35);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.25);
	  //rmAddRandomTradeRouteWaypoints(tradeRouteID, 0.2, 0.3, 10, 4);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
/*================================================================================================================*/  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.02);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.98);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************** ISLES OF SHOALS - THESE ARE SET IN SPECIFIC LOCATIONS: **************************** //
/*================================================================================================================*/
        int bonusIslandID1=rmCreateArea("isle of shoals 1");
        //rmSetAreaSize(bonusIslandID1, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
		rmSetAreaSize(bonusIslandID1, 0.015, 0.015);	
        rmSetAreaTerrainType(bonusIslandID1, "new_england\ground1_ne");
        rmSetAreaMix(bonusIslandID1, "newengland_grass");
	    // rmSetAreaMix(bonusIslandID1, "newengland_rock");
        rmSetAreaBaseHeight(bonusIslandID1, 6.0);
        rmSetAreaSmoothDistance(bonusIslandID1, 5);
        rmSetAreaWarnFailure(bonusIslandID1, false);
	    rmSetAreaMinBlobs(bonusIslandID1, 1);
        rmSetAreaMaxBlobs(bonusIslandID1, 1);
        rmSetAreaMinBlobDistance(bonusIslandID1, 1);
	    rmSetAreaMaxBlobDistance(bonusIslandID1, 1);
        rmSetAreaCoherence(bonusIslandID1, 0.50);
        //rmAddAreaConstraint(bonusIslandID1, bigContinentConstraint);
        //rmAddAreaConstraint(bonusIslandID1, longPlayerConstraint);
        rmSetAreaLocation(bonusIslandID1, 0.25, 0.25);
		rmBuildArea(bonusIslandID1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.58);
/*================================================================================================================*/
//  *********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("iroquois"))
	{  
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingConstraint(iroquois1VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois1VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.6, 0.9);
	} 
	
	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingConstraint(iroquois2VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquois2VillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.9, 0.6);
	} 
	
	if (subCiv2 == rmGetCivID("iroquois"))
	{  
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingConstraint(iroquois3VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		rmAddGroupingConstraint(iroquois3VillageID, avoidRegion);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.375, 0.525);
	} 
	
	if (subCiv3 == rmGetCivID("iroquois"))
	{  
		int iroquois4VillageID = -1;
		iroquois4VillageID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois4VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois4VillageID, 0.0);
		rmAddGroupingConstraint(iroquois4VillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquois4VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois4VillageID, avoidNatives);
		rmAddGroupingConstraint(iroquois4VillageID, avoidRegion);
		rmPlaceGroupingAtLoc(iroquois4VillageID, 0, 0.525, 0.375);
	} 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.59);
/*================================================================================================================*/
// ******************************** DEFINE THE STARTING TCID AND STARTING UNITS: ******************************** //
/*================================================================================================================*/ 
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
	    int silverType = -1;
	    int playerGoldID = -1;

	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	    int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    rmAddObjectDefConstraint(playerNuggetID, avoidGold);

	    int waterFlagID=-1;
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
	    for(i=1; <cNumberPlayers)
	{
	
		rmClearClosestPointConstraints();
		
		// PLACE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS ONE ORE GROUPING CLOSE BY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidGold);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACING STARTING PRONGHORNS:
		/*
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		*/
		
		// PLACING STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACING STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE WATER FLAG: *************************************** //
/*================================================================================================================*/
		// WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		rmClearClosestPointConstraints();
/*================================================================================================================*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE GOLD MINES: *************************************** //
/*================================================================================================================*/
        int Gold2ID=rmCreateObjectDef("The Gold Mine 2");
        rmAddObjectDefItem(Gold2ID, "minegold", 1, 0.0);
        rmSetObjectDefMinDistance(Gold2ID, 0.0);
        rmSetObjectDefMaxDistance(Gold2ID, 0.0);
        rmAddObjectDefConstraint(Gold2ID, avoidGold);
	    rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.5, 0.95);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.95, 0.5);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.7, 0.925);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.925, 0.7);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.8, 0.8);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.25, 0.25);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.5, 0.7);
		rmPlaceObjectDefAtLoc(Gold2ID, 0, 0.7, 0.5);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        int Berries1ID=rmCreateObjectDef("The Berries");
        rmAddObjectDefItem(Berries1ID, "berrybush", rmRandInt(3,5), 6.0);
        rmSetObjectDefMinDistance(Berries1ID, 0.0);
        rmSetObjectDefMaxDistance(Berries1ID, 0.0);
        rmAddObjectDefConstraint(Berries1ID, avoidFruits);
	    rmAddObjectDefConstraint(Berries1ID, avoidRegion);
	    rmAddObjectDefConstraint(Berries1ID, playerConstraint);
	    //rmAddObjectDefConstraint(Berries1ID, avoidCliffs);
        //rmAddObjectDefConstraint(Berries1ID, avoidWater8);
	    rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.25, 0.7);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.7, 0.25);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.45, 0.95);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.95, 0.45);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.75, 0.85);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.85, 0.75);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.55, 0.4);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.4, 0.55);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.48, 0.8);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.80, 0.48);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.20, 0.85);
		rmPlaceObjectDefAtLoc(Berries1ID, 0, 0.85, 0.20);
/*================================================================================================================*/
        int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,5), 3.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, 0.0);
        rmAddObjectDefConstraint(Berries2ID, avoidFruits);
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.235, 0.235);	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE RANDOM TREES: ************************************* //
/*================================================================================================================*/
        int Trees1ID=rmCreateObjectDef("The Random Trees");
        rmAddObjectDefItem(Trees1ID, "TreeNewEngland", rmRandInt(5,9), 6.0);
		rmSetObjectDefMinDistance(Trees1ID, 0.0);
		rmSetObjectDefMaxDistance(Trees1ID, 0.0);
        rmAddObjectDefConstraint(Trees1ID, avoidTrees);
	    rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.45, 0.55);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.55, 0.45);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.45, 0.85);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.85, 0.45);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.4, 0.7);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.7, 0.4);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.65, 0.95);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.95, 0.65);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.55, 0.95);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.95, 0.55);
		rmPlaceObjectDefAtLoc(Trees1ID, 0, 0.475, 0.475);
/*================================================================================================================*/
        int Trees2ID=rmCreateObjectDef("The Random Trees 2");
        rmAddObjectDefItem(Trees2ID, "TreeNewEngland", rmRandInt(5,9), 6.0);
		rmSetObjectDefMinDistance(Trees2ID, 0.0);
		rmSetObjectDefMaxDistance(Trees2ID, 0.0);
        rmAddObjectDefConstraint(Trees2ID, avoidTrees);
	    rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.4, 0.95);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.95, 0.4);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.74, 0.91);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.9, 0.75);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.8, 0.85);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.85, 0.8);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.9, 0.525);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.525, 0.9);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.25, 0.85);
		rmPlaceObjectDefAtLoc(Trees2ID, 0, 0.85, 0.25);
/*================================================================================================================*/		
		int Trees3ID=rmCreateObjectDef("The Random Trees 3");
        rmAddObjectDefItem(Trees3ID, "TreeNewEngland", rmRandInt(3,5), 3.0);
		rmSetObjectDefMinDistance(Trees3ID, 0.0);
		rmSetObjectDefMaxDistance(Trees3ID, 0.0);
        rmAddObjectDefConstraint(Trees3ID, avoidTrees);
	    rmPlaceObjectDefAtLoc(Trees3ID, 0, 0.27, 0.27);
		rmPlaceObjectDefAtLoc(Trees3ID, 0, 0.23, 0.275);
		rmPlaceObjectDefAtLoc(Trees3ID, 0, 0.275, 0.23);
		rmPlaceObjectDefAtLoc(Trees3ID, 0, 0.215, 0.215);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
        int nuggetID= rmCreateObjectDef("The NuggetS"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, 0.0);
	    rmAddObjectDefConstraint(nuggetID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nuggetID, 0, 0.55, 0.85);	
        rmPlaceObjectDefAtLoc(nuggetID, 0, 0.85, 0.55);	
        rmPlaceObjectDefAtLoc(nuggetID, 0, 0.275, 0.75);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.75, 0.265);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.475, 0.90);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.90, 0.475);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.70, 0.875);
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.875, 0.70);
/*================================================================================================================*/
		int nugget2ID= rmCreateObjectDef("The NuggetS 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
  	    rmSetNuggetDifficulty(1, 4);
	    rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.6, 0.95);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.95, 0.6);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.35, 0.6);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.6, 0.35);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.45, 0.75);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.75, 0.45);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE DEERS: ****************************************** //
/*================================================================================================================*/
        int Deers2ID= rmCreateObjectDef("The Deers 2"); 
	    rmAddObjectDefItem(Deers2ID, "deer", rmRandInt(7,9), 5.0);
		rmSetObjectDefCreateHerd(Deers2ID, true);
	    rmSetObjectDefMinDistance(Deers2ID, 0.0);
	    rmSetObjectDefMaxDistance(Deers2ID, 0.0);
	    rmAddObjectDefConstraint(Deers2ID, avoidDeer);
  	    rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.65, 0.9);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.9, 0.65);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.425, 0.625);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.625, 0.425);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.285, 0.685);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.685, 0.285);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.525, 0.825);
		rmPlaceObjectDefAtLoc(Deers2ID, 0, 0.825, 0.525);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE BIG FOREST: *************************************** //
/*================================================================================================================*/
        //int forestTreeID = 0;
		int ForestID=rmCreateArea("The Forest"+i);
		rmSetAreaWarnFailure(ForestID, false);
		rmSetAreaSize(ForestID, 0.07, 0.07);
		//rmSetAreaSize(ForestID, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
		rmSetAreaForestType(ForestID, "new england forest");
		rmSetAreaForestDensity(ForestID, 0.7);
		rmSetAreaForestClumpiness(ForestID, 0.4);
		rmSetAreaForestUnderbrush(ForestID, 0.0);
		rmSetAreaMinBlobs(ForestID, 1);
		rmSetAreaMaxBlobs(ForestID, 1);
		rmSetAreaMinBlobDistance(ForestID, 1);
		rmSetAreaMaxBlobDistance(ForestID, 1);
		rmSetAreaCoherence(ForestID, 0.4);
		rmSetAreaSmoothDistance(ForestID, 10);
		rmAddAreaConstraint(ForestID, forestConstraint);
		rmAddAreaConstraint(ForestID, avoidGold);
		//rmAddAreaConstraint(ForestID, avoidTrees);
		rmAddAreaConstraint(ForestID, avoidFruits);
		rmAddAreaConstraint(ForestID, avoidNatives);
		rmAddAreaConstraint(ForestID, avoidTradeRoute);
		rmAddAreaConstraint(ForestID, avoidSocket);
        rmSetAreaLocation(ForestID, 0.65, 0.65);
        rmBuildArea(ForestID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //
/*================================================================================================================*/
        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishCod", 3, 6.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*15);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FAST COIN -- WHALES: *********************************** //
/*================================================================================================================*/
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}  
/*================================================================================================================*/
// ************************************ THIS IS THE END OF THE MAP: ********************************************* //
/*================================================================================================================*/





















